Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions
Lucene::IndexDeletionPolicy Class Referenceabstract

Policy for deletion of stale index commits. Implement this interface, and pass it to one of the IndexWriter or IndexReader constructors, to customize when older point-in-time commits are deleted from the index directory. The default deletion policy is KeepOnlyLastCommitDeletionPolicy, which always removes old commits as soon as a new commit is done (this matches the behavior before 2.2). More...

`#include <IndexDeletionPolicy.h>`

Inheritance diagram for Lucene::IndexDeletionPolicy:

## Public Member Functions

virtual | ~IndexDeletionPolicy ()
virtual String | getClassName ()
boost::shared_ptr < IndexDeletionPolicy > | shared_from_this ()
virtual void | onInit (Collection< IndexCommitPtr > commits)=0
| This is called once when a writer is first instantiated to give the policy a chance to remove old commit points. More...
virtual void | onCommit (Collection< IndexCommitPtr > commits)=0
| This is called each time the writer completed a commit. This gives the policy a chance to remove old commit points with each commit. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (LuceneObjectPtr other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (LuceneObjectPtr other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (LuceneObjectPtr other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()

## Protected Member Functions

| IndexDeletionPolicy ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Additional Inherited Members

Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Policy for deletion of stale index commits. Implement this interface, and pass it to one of the IndexWriter or IndexReader constructors, to customize when older point-in-time commits are deleted from the index directory. The default deletion policy is KeepOnlyLastCommitDeletionPolicy, which always removes old commits as soon as a new commit is done (this matches the behavior before 2.2).

One expected use case for this (and the reason why it was first created) is to work around problems with an index directory accessed via filesystems like NFS because NFS does not provide the "delete on last close" semantics that Lucene's "point in time" search normally relies on. By implementing a custom deletion policy, such as "a commit is only removed once it has been stale for more than X minutes", you can give your readers time to refresh to the new commit before IndexWriter removes the old commits. Note that doing so will increase the storage requirements of the index.

## Constructor & Destructor Documentation

Lucene::IndexDeletionPolicy::IndexDeletionPolicy | ( | ) |  |

protected

virtual Lucene::IndexDeletionPolicy::~IndexDeletionPolicy | ( | ) |  |

virtual

## Member Function Documentation

static String Lucene::IndexDeletionPolicy::_getClassName | ( | ) |  |

inline static

virtual String Lucene::IndexDeletionPolicy::getClassName | ( | ) |  |

inline virtual

Reimplemented in Lucene::KeepOnlyLastCommitDeletionPolicy, and Lucene::SnapshotDeletionPolicy.

virtual void Lucene::IndexDeletionPolicy::onCommit | ( | Collection< IndexCommitPtr > | commits) |  |

pure virtual

This is called each time the writer completed a commit. This gives the policy a chance to remove old commit points with each commit.

The policy may now choose to delete old commit points by calling method delete() of IndexCommit.

This method is only called when IndexWriter#commit or IndexWriter#close is called, or possibly not at all if the IndexWriter#rollback is called.

Note: the last CommitPoint is the most recent one, ie. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

Parameters

  commits | List of IndexCommit, sorted by age (the 0th one is the oldest commit).

Implemented in Lucene::SnapshotDeletionPolicy, and Lucene::KeepOnlyLastCommitDeletionPolicy.

virtual void Lucene::IndexDeletionPolicy::onInit | ( | Collection< IndexCommitPtr > | commits) |  |

pure virtual

This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.

The writer locates all index commits present in the index directory and calls this method. The policy may choose to delete some of the commit points, doing so by calling method delete() of IndexCommit.

Note: the last CommitPoint is the most recent one, ie. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

Parameters

  commits | List of current point-in-time commits, sorted by age (the 0th one is the oldest commit).

Implemented in Lucene::SnapshotDeletionPolicy, and Lucene::KeepOnlyLastCommitDeletionPolicy.

boost::shared_ptr< IndexDeletionPolicy > Lucene::IndexDeletionPolicy::shared_from_this | ( | ) |  |

inline

The documentation for this class was generated from the following file:

- IndexDeletionPolicy.h

clucene.sourceforge.net